; esi - source
; edx - end ptr
compress:
	push	esi
	mov	edi, esi ; sacral
	xor	eax, eax
	xor	ebx, ebx
	xor	ecx, ecx
  .lp:	lodsw
	cmp	ax, bx
	jne	.flush
	inc	cx
	jmp	.lp
      .flush:
	test	cx, cx
	jz	.write_opcode
	mov	[edi], cx
	inc	edi
	inc	edi
	xor	cx, cx
      .write_opcode:
	xchg	ax, bx
	test	ax, ax
	jz	.lp
	stosw
	cmp	esi, edx
	jz	.ret
	jmp	.lp
.ret:	mov	ax, ''
	stosw
	mov	eax, edi
	pop	edi
	sub	eax, edi
	ret

; esi - source
; ebx - key
; ecx - size
encrypt:
	mov	edi, esi ; sacral
      .lp:
	lodsb
	cmp	al, ''
	jz	.ret
	xor	al, bl
	stosb
	loop .lp
.ret:	ret

SECTION_SIZE_OFFSET = 0x00000188
SECTION_VSIZ_OFFSET = 0x00000180
ENTRY_OFFSET	    = 0x000003AC
SECTION_OFFSET	    = ENTRY_OFFSET - 0x00000200
IMAGE_SIZE_OFFSET   = 0x000000D0

COMCODE_SIZE_OFFSET = 0x0000034B
OPTIONS_OFFET	    = 0x0000034F


; esi - code
; edx - size
make:
	push	esi
	mov	esi, stub
	mov	ecx, stub_size
.stub_lp:
	lodsb
	call	write1
	loop	.stub_lp
	pop	esi
	mov	eax, SECTION_SIZE_OFFSET
	call	seek
	mov	eax, edx
	add	eax, SECTION_OFFSET
	shr	eax, 9
	inc	eax
	imul	eax, 512
	call	write4
	push	eax
	mov	eax, SECTION_VSIZ_OFFSET
	call	seek
	pop	eax
	call	write4
	push	eax
	mov	eax, IMAGE_SIZE_OFFSET
	call	seek
	pop	eax
	push	eax
	shr	eax, 12
	inc	eax
	inc	eax
	imul	eax, 4096
	call	write4
	pop	eax
	sub	eax, SECTION_OFFSET
	mov	ecx, eax
	mov	eax, ENTRY_OFFSET
	call	seek
      .lp:
	lodsb
	cmp	al, ''
	jnz	.sad
	dec	esi
.sad:
	call	write1
	loop	.lp
	mov	eax, COMCODE_SIZE_OFFSET
	call	seek
	mov	eax, [ExtractedSize]
	call	write4
	mov	eax, OPTIONS_OFFET
	call	seek
	mov	eax, [cOptions]
	call	write4
ret

; esi - code
; edx - size
wav:
	mov	eax, 'RIFF'
	call	write4
	mov	eax, edx
	add	eax, 36
	call	write4
	mov	eax, 'WAVE'
	call	write4
	mov	eax, 'fmt '
	call	write4
	mov	eax, 16
	call	write4
	mov	eax, 0x00010001
	call	write4
	mov	eax, 11025
	call	write4
	mov	eax, 22050
	call	write4
	mov	eax, 0x00100002
	call	write4
	mov	eax, 'data'
	call	write4
	mov	eax, edx
	call	write4
	mov	ecx, edx
   .lp: lodsb
	call	write1
	loop	.lp
ret

stub:
   include 'stub.inc'
stub_size = $-stub